## ustr 1.0.3

=== Makefile ===

# FIXME: Lots of C&P of VERSION ... 
#   ustr*.pc, ustr.spec, Documentation/*.pl, Documentation/ustr-import.1,
#   ./scripts/rpms-create-james.sh
VERS=1.0
VERS_FULL=$(VERS).3
VERS_BSO =1.0
VERS_ESONAME =1
VERS_ESO     =$(VERS_ESONAME).0.3

DESTDIR =
prefix=/usr
datadir=$(prefix)/share
libdir=$(prefix)/lib
bindir=$(prefix)/bin
includedir=$(prefix)/include
SHRDIR=$(datadir)/ustr-$(VERS_FULL)
DOCSHRDIR=$(datadir)/doc/ustr-devel-$(VERS_FULL)
EXAMDIR=$(datadir)/ustr-$(VERS_FULL)/examples
mandir=$(datadir)/doc/man

###############################################################################
#  This is here to work around the "Fedora build system requirement" that a big
# pile of crap ends up in the build.log file even though all sane people don't
# want that. See rhbz#248231
###############################################################################
HIDE=@

CC = cc
AR = ar
RANLIB = ranlib
LDCONFIG = /sbin/ldconfig

CFLAGS  = -O2 -g

# Debug versions...
WARNS = -W -Wall -Wundef -Wshadow -Wpointer-arith -Wbad-function-cast -Wcast-align -Wwrite-strings -Waggregate-return -Wstrict-prototypes -Wmissing-prototypes -Wmissing-declarations -Wnested-externs -Wno-format-zero-length -Wformat-nonliteral -Wformat-security # -Wfloat-equal -- no floats
#  Fedora policies/"reviewers" are completely retarded and refuse to allow
# lowering the "Fedora build flags" even when it activley hurts their users,
# this makes it easier for them to hurt you. Welcome to the lowest common
# denominator collective.
DBG_ONLY_BAD_POLICIES_HAVE_THIS_EMPTY_CFLAGS=-O1
DBG_CFLAGS = $(CFLAGS) $(WARNS) $(DBG_ONLY_BAD_POLICIES_HAVE_THIS_EMPTY_CFLAGS)

# Inline tst_*.c and otst_*.c files.
CFLG_TST =

CFLG_TST_C = $(CFLG_TST) \
             -DUSTR_CONF_INCLUDE_CODEONLY_HEADERS=1 -DUSTR_CONF_REF_BYTES=4

# Optimized o*.c files
CFLG_TST_O  = -DUSTR_DEBUG=0 $(CFLG_TST)
CFLG_TST_CO = -DUSTR_DEBUG=0 $(CFLG_TST_C)

# fread64/etc.
CFLG_LIB = -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64

CFLG_LIB_OPT = $(CFLG_LIB) -DNDEBUG
CFLG_LIB_DBG = $(CFLG_LIB)

DOCS = README-DEVELOPERS TODO \
       Documentation/strdup\ vs.\ ustr.gnumeric \
       Documentation/index.html \
       Documentation/functions.html \
       Documentation/constants.html \
       Documentation/design.html \
       Documentation/tutorial.html

MAN_PAGES_1 = \
       Documentation/ustr-import.1

MAN_PAGES_3 = \
       Documentation/ustr.3 \
       Documentation/ustr_const.3

EXAMPLES = examples/Makefile \
       examples/custr.c \
       examples/fgrep.c \
       examples/hello_world.c \
       examples/hexdump.c \
       examples/linecat.c \
       examples/mkdir_p.c \
       examples/netstr.c \
       examples/nums.c \
       examples/txt2html.c

#  Some versions of GCC really don't like all the includes with inline stuff.
# so we allow the library only to be checked. This is _bad_ for a release as
# it basically means ustr-import usage (without -c) will kill GCC too.
TST_STATIC_ALL =  tst_0_sizes  tst_0_manual   \
          otst_0_sizes otst_0_manual \
           tst_0_nothing \
          otst_0_nothing \
           tst_1_basic \
          otst_1_basic \
           tst_2_small \
          otst_2_small \
           tst_3_medium \
          otst_3_medium \
           tst_4_grow \
          otst_4_grow \
           tst_5_shrink \
          otst_5_shrink \
           tst_6_tiny \
          otst_6_tiny \
           tst_7_auto \
          otst_7_auto \
           tst_8_spn \
          otst_8_spn \
           tst_9_ins \
          otst_9_ins \
           tst_10_b  \
          otst_10_b  \
           tst_11_io \
          otst_11_io \
           tst_12_fmt \
          otst_12_fmt \
           tst_13_utf8 \
          otst_13_utf8 \
           tst_14_cmp  \
          otst_14_cmp  \
           tst_15_trim \
          otst_15_trim \
           tst_16_parse \
          otst_16_parse \
           tst_17_sub   \
          otst_17_sub   \
           tst_18_split \
          otst_18_split \
           tst_98_pool  \
          otst_98_pool  \
           tst_99_enomem \
          otst_99_enomem \
           tst_99_64bit  \
          otst_99_64bit

TST_ALL =  ctst_0_cntl \
          octst_0_cntl \
           ctst_0_nothing \
          octst_0_nothing \
           ctst_3_medium \
          octst_3_medium \
           ctst_4_grow \
          octst_4_grow \
           ctst_5_shrink \
          octst_5_shrink \
           ctst_7_auto \
          octst_7_auto \
           ctst_8_spn \
          octst_8_spn \
           ctst_9_ins \
          octst_9_ins \
           ctst_10_b \
          octst_10_b \
           ctst_11_io \
          octst_11_io \
           ctst_12_fmt \
          octst_12_fmt \
           ctst_13_utf8 \
          octst_13_utf8 \
           ctst_14_cmp \
          octst_14_cmp \
           ctst_15_trim \
          octst_15_trim \
           ctst_16_parse \
          octst_16_parse \
           ctst_17_sub \
          octst_17_sub \
           ctst_18_split \
          octst_18_split \
           ctst_98_pool \
          octst_98_pool \
           ctst_99_enomem \
          octst_99_enomem \
           ctst_99_64bit \
          octst_99_64bit \
          $(TST_STATIC_ALL)
XFAIL_TESTS = 

SRC_HDRS = ustr.h      ustr-debug.h \
           ustr-conf.h ustr-conf-debug.h \
           ustr-b.h \
           ustr-cmp.h \
           ustr-cntl.h \
           ustr-compiler.h \
           ustr-fmt.h \
           ustr-io.h \
           ustr-ins.h \
           ustr-main.h \
           ustr-parse.h \
           ustr-pool.h \
           ustr-replace.h \
           ustr-sc.h \
           ustr-set.h \
           ustr-split.h \
           ustr-spn.h \
           ustr-srch.h \
           ustr-sub.h \
           ustr-utf8.h

SRC_HDRS_MULTI_LIB = \
           ustr-conf-multilib-linux.h ustr-conf-debug-multilib-linux.h \

SRC_SRCS_H = malloc-check.h \
             ustr-b-code.h \
             ustr-cmp-code.h \
             ustr-cmp-internal.h \
             ustr-cntl-code.h \
             ustr-fmt-code.h \
             ustr-fmt-internal.h \
             ustr-io-code.h \
             ustr-io-internal.h \
             ustr-ins-code.h \
             ustr-ins-internal.h \
             ustr-main-code.h \
             ustr-main-internal.h \
             ustr-parse-code.h \
             ustr-pool-code.h \
             ustr-replace-code.h \
             ustr-replace-internal.h \
             ustr-sc-code.h \
             ustr-sc-internal.h \
             ustr-set-code.h \
             ustr-set-internal.h \
             ustr-split-code.h \
             ustr-split-internal.h \
             ustr-spn-code.h \
             ustr-srch-code.h \
             ustr-srch-internal.h \
             ustr-sub-code.h \
             ustr-sub-internal.h \
             ustr-utf8-code.h \
             ustr-utf8-internal.h

SRC_SRCS_C = ustr-b-dbg-code.c \
             ustr-cmp-dbg-code.c \
             ustr-fmt-dbg-code.c \
             ustr-io-dbg-code.c \
             ustr-ins-dbg-code.c \
             ustr-main-dbg-code.c \
             ustr-parse-dbg-code.c \
             ustr-pool-dbg-code.c \
             ustr-replace-dbg-code.c \
             ustr-sc-dbg-code.c \
             ustr-set-dbg-code.c \
             ustr-split-dbg-code.c \
             ustr-spn-dbg-code.c \
             ustr-srch-dbg-code.c \
             ustr-sub-dbg-code.c \
             ustr-utf8-dbg-code.c \
             \
             ustr-b-opt-code.c \
             ustr-cmp-opt-code.c \
             ustr-fmt-opt-code.c \
             ustr-io-opt-code.c \
             ustr-ins-opt-code.c \
             ustr-main-opt-code.c \
             ustr-parse-opt-code.c \
             ustr-pool-opt-code.c \
             ustr-replace-opt-code.c \
             ustr-sc-opt-code.c \
             ustr-set-opt-code.c \
             ustr-split-opt-code.c \
             ustr-spn-opt-code.c \
             ustr-srch-opt-code.c \
             ustr-sub-opt-code.c \
             ustr-utf8-opt-code.c

SRC_SRCS = $(SRC_SRCS_C) $(SRC_SRCS_H)
XSRC_SRCS = .gdbinit

DBG_LIB_SHAREDEV    = libustr-debug.so
DBG_LIB_SHARED_NAME = libustr-debug-$(VERS_BSO).so.$(VERS_ESONAME)
DBG_LIB_SHARED      = libustr-debug-$(VERS_BSO).so.$(VERS_ESO)
DBG_LIB_STATIC      = libustr-debug.a

OPT_LIB_SHAREDEV    = libustr.so
OPT_LIB_SHARED_NAME = libustr-$(VERS_BSO).so.$(VERS_ESONAME)
OPT_LIB_SHARED      = libustr-$(VERS_BSO).so.$(VERS_ESO)
OPT_LIB_STATIC      = libustr.a

LIB_SHARED = $(DBG_LIB_SHARED) $(OPT_LIB_SHARED)
LIB_STATIC = $(DBG_LIB_STATIC) $(OPT_LIB_STATIC)

DEPS_NONC_ALL  = $(SRC_HDRS) $(SRC_SRCS_H)
DEPS_C_ALL     = $(SRC_HDRS)
OBJS_C_DBG_ALL = $(DBG_LIB_STATIC)
OBJS_C_OPT_ALL = $(OPT_LIB_STATIC)

LIB_SHARED_DBG = \
  ustr-b-code-so-dbg.o \
  ustr-cmp-code-so-dbg.o \
  ustr-fmt-code-so-dbg.o \
  ustr-io-code-so-dbg.o \
  ustr-ins-code-so-dbg.o \
  ustr-main-code-so-dbg.o \
  ustr-parse-code-so-dbg.o \
  ustr-pool-code-so-dbg.o \
  ustr-replace-code-so-dbg.o \
  ustr-sc-code-so-dbg.o \
  ustr-set-code-so-dbg.o \
  ustr-split-code-so-dbg.o \
  ustr-spn-code-so-dbg.o \
  ustr-srch-code-so-dbg.o \
  ustr-sub-code-so-dbg.o \
  ustr-utf8-code-so-dbg.o
LIB_STATIC_DBG = \
  ustr-b-code-a-dbg.o \
  ustr-cmp-code-a-dbg.o \
  ustr-fmt-code-a-dbg.o \
  ustr-io-code-a-dbg.o \
  ustr-ins-code-a-dbg.o \
  ustr-main-code-a-dbg.o \
  ustr-parse-code-a-dbg.o \
  ustr-pool-code-a-dbg.o \
  ustr-replace-code-a-dbg.o \
  ustr-sc-code-a-dbg.o \
  ustr-set-code-a-dbg.o \
  ustr-split-code-a-dbg.o \
  ustr-spn-code-a-dbg.o \
  ustr-srch-code-a-dbg.o \
  ustr-sub-code-a-dbg.o \
  ustr-utf8-code-a-dbg.o

LIB_SHARED_OPT = \
  ustr-b-code-so-opt.o \
  ustr-cmp-code-so-opt.o \
  ustr-fmt-code-so-opt.o \
  ustr-io-code-so-opt.o \
  ustr-ins-code-so-opt.o \
  ustr-main-code-so-opt.o \
  ustr-parse-code-so-opt.o \
  ustr-pool-code-so-opt.o \
  ustr-replace-code-so-opt.o \
  ustr-sc-code-so-opt.o \
  ustr-set-code-so-opt.o \
  ustr-split-code-so-opt.o \
  ustr-spn-code-so-opt.o \
  ustr-srch-code-so-opt.o \
  ustr-sub-code-so-opt.o \
  ustr-utf8-code-so-opt.o
LIB_STATIC_OPT = \
  ustr-b-code-a-opt.o \
  ustr-cmp-code-a-opt.o \
  ustr-fmt-code-a-opt.o \
  ustr-io-code-a-opt.o \
  ustr-ins-code-a-opt.o \
  ustr-main-code-a-opt.o \
  ustr-parse-code-a-opt.o \
  ustr-pool-code-a-opt.o \
  ustr-replace-code-a-opt.o \
  ustr-sc-code-a-opt.o \
  ustr-set-code-a-opt.o \
  ustr-split-code-a-opt.o \
  ustr-spn-code-a-opt.o \
  ustr-srch-code-a-opt.o \
  ustr-sub-code-a-opt.o \
  ustr-utf8-code-a-opt.o


all: ustr-import $(LIB_STATIC)
		$(HIDE)echo Done static

all-shared: all $(LIB_SHARED)
		$(HIDE)echo Done shared

install: all-shared ustr.pc ustr-debug.pc
		$(HIDE)echo Making directories
		install -d $(DESTDIR)$(libdir)
		install -d $(DESTDIR)$(includedir)
		install -d $(DESTDIR)$(SHRDIR)
		install -d $(DESTDIR)$(DOCSHRDIR)
		install -d $(DESTDIR)$(EXAMDIR)
		install -d $(DESTDIR)$(mandir)/man1
		install -d $(DESTDIR)$(mandir)/man3
		install -d $(DESTDIR)$(bindir)
		install -d $(DESTDIR)$(libdir)/pkgconfig
		$(HIDE)echo Installing files
		install -m 644 -t $(DESTDIR)$(libdir) $(LIB_STATIC)
		install -m 755 -t $(DESTDIR)$(libdir) $(LIB_SHARED)
		-rm -f $(DESTDIR)$(libdir)/$(OPT_LIB_SHARED_NAME)
		ln -s $(OPT_LIB_SHARED) $(DESTDIR)$(libdir)/$(OPT_LIB_SHARED_NAME)
		-rm -f $(DESTDIR)$(libdir)/$(OPT_LIB_SHAREDEV)
		ln -s $(OPT_LIB_SHARED_NAME) $(DESTDIR)$(libdir)/$(OPT_LIB_SHAREDEV)
		-rm -f $(DESTDIR)$(libdir)/$(DBG_LIB_SHARED_NAME)
		ln -s $(DBG_LIB_SHARED) $(DESTDIR)$(libdir)/$(DBG_LIB_SHARED_NAME)
		-rm -f $(DESTDIR)$(libdir)/$(DBG_LIB_SHAREDEV)
		ln -s $(DBG_LIB_SHARED_NAME) $(DESTDIR)$(libdir)/$(DBG_LIB_SHAREDEV)
		$(LDCONFIG) -n $(DESTDIR)$(libdir)
		install -m 644 -t $(DESTDIR)$(includedir) $(SRC_HDRS)
		install -m 644 -t $(DESTDIR)$(SHRDIR) $(SRC_SRCS)
		install -m 644 -t $(DESTDIR)$(SHRDIR) $(XSRC_SRCS)
		install -m 644 -t $(DESTDIR)$(DOCSHRDIR) $(DOCS)
		install -m 644 -t $(DESTDIR)$(EXAMDIR) $(EXAMPLES)
		install -m 644 -t $(DESTDIR)$(mandir)/man1 $(MAN_PAGES_1)

=== examples/Makefile ===


CC = cc
AR = ar
RANLIB = ranlib


WARNS = -W -Wall -Wundef -Wshadow -Wpointer-arith -Wbad-function-cast -Wcast-align -Wwrite-strings -Waggregate-return -Wstrict-prototypes -Wmissing-prototypes -Wmissing-declarations -Wnested-externs -Wno-format-zero-length -Wformat-nonliteral -Wformat-security # -Wfloat-equal -- no floats

# DEF_CFLAGS = -Os -g
DEF_CFLAGS = -O2 -g # $(WARNS)

CFLG_LFS = -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64

CFLAGS  = $(DEF_CFLAGS) $(CFLG_LFS)

CFLG_LIB_OPT = $(CFLAGS) -DUSTR_DEBUG=0 -DNDEBUG
CFLG_LIB_DBG = $(CFLAGS)

# Compile "normal" using /ustr/include/ustr*.h and /usr/lib/libustr.so
PCFLAGS = $(CFLAGS)
LDFLAGS = -lustr
DEPS    =

## Compile "debug" using /ustr/include/ustr*.h and /usr/lib/libustr-debug.so
#PCFLAGS = $(CFLAGS) $(WARNS) -DUSTR_DEBUG=1
#LDFLAGS = -lustr-debug
#DEPS    =

## Compile "inline" using parent dir.
#PCFLAGS = $(CFLAGS) -DUSTR_CONF_INCLUDE_CODEONLY_HEADERS=1 -I..
#LDFLAGS =

## Compile "static" using parent dir.
#PCFLAGS = $(CFLAGS) -I..
#LDFLAGS = ../libustr.a
#PCFLAGS = $(CFLAGS) $(WARNS) -I.. -DUSTR_DEBUG=1
#LDFLAGS = ../libustr-debug.a

## Compile "inline" using ustr-import output
# - do nothing

## Compile "inline" using /ustr/include/ustr*.h / ustr-import -c
#PCFLAGS = $(CFLAGS) -DUSTR_CONF_INCLUDE_CODEONLY_HEADERS=1
#LDFLAGS  =

## Compile "static" opt using ustr-import
#PCFLAGS = $(CFLAGS)
#DEPS    = libustr.a
#LDFLAGS = libustr.a

## Compile "static" dbg using ustr-import
#PCFLAGS = $(CFLAGS) $(WARNS)
#DEPS    = libustr-debug.a
#LDFLAGS = libustr-debug.a


# This is a simple makefile for example programs...

ALL = hello_world netstr hexdump nums mkdir_p fgrep txt2html custr \
      linecat_buf linecat_sized

DBG_LIB_STATIC      = libustr-debug.a
OPT_LIB_STATIC      = libustr.a
LIB_STATIC = $(DBG_LIB_STATIC) $(OPT_LIB_STATIC)

LIB_STATIC_DBG = \
  ustr-b-code-a-dbg.o \
  ustr-cmp-code-a-dbg.o \
  ustr-fmt-code-a-dbg.o \
  ustr-io-code-a-dbg.o \
  ustr-ins-code-a-dbg.o \
  ustr-main-code-a-dbg.o \
  ustr-parse-code-a-dbg.o \
  ustr-pool-code-a-dbg.o \
  ustr-sc-code-a-dbg.o \
  ustr-set-code-a-dbg.o \
  ustr-spn-code-a-dbg.o \
  ustr-srch-code-a-dbg.o \
  ustr-utf8-code-a-dbg.o
LIB_STATIC_OPT = \
  ustr-b-code-a-opt.o \
  ustr-cmp-code-a-opt.o \
  ustr-fmt-code-a-opt.o \
  ustr-io-code-a-opt.o \
  ustr-ins-code-a-opt.o \
  ustr-main-code-a-opt.o \
  ustr-parse-code-a-opt.o \
  ustr-pool-code-a-opt.o \
  ustr-sc-code-a-opt.o \
  ustr-set-code-a-opt.o \
  ustr-spn-code-a-opt.o \
  ustr-srch-code-a-opt.o \
  ustr-utf8-code-a-opt.o




all: $(DEPS) $(ALL)

libustr.a: $(LIB_STATIC_OPT)
		@echo Linking A OPT lib: $@
		@$(AR) ru $@ $^
		@$(RANLIB) $@
libustr-debug.a: $(LIB_STATIC_DBG)
		@echo Linking A DBG lib: $@
		@$(AR) ru $@ $^
		@$(RANLIB) $@

%-code-a-opt.o:  %-opt-code.c %-code.h %.h
		@echo Compiling for A OPT lib: $<
		@$(CC) $(CFLG_LIB_OPT) -o $@ -c $<

%-code-a-dbg.o:  %-dbg-code.c %-code.h %.h
		@echo Compiling for A DBG lib: $<
		@$(CC) $(CFLG_LIB_DBG) -o $@ -c $<

hello_world: hello_world.c
		$(CC) $(PCFLAGS) -o $@ $< $(LDFLAGS)

netstr: netstr.c
		$(CC) $(PCFLAGS) -o $@ $< $(LDFLAGS)

hexdump: hexdump.c
		$(CC) $(PCFLAGS) -o $@ $< $(LDFLAGS)

nums: nums.c
		$(CC) $(PCFLAGS) -o $@ $< $(LDFLAGS)

mkdir_p: mkdir_p.c
		$(CC) $(PCFLAGS) -o $@ $< $(LDFLAGS)

fgrep: fgrep.c
		$(CC) $(PCFLAGS) -o $@ $< $(LDFLAGS)

txt2html: txt2html.c
		$(CC) $(PCFLAGS) -o $@ $< $(LDFLAGS)

custr: custr.c
		$(CC) $(PCFLAGS) -o $@ $< $(LDFLAGS)

linecat_buf: linecat.c
		$(CC) $(PCFLAGS) -o $@ $< $(LDFLAGS) -DCAT_TYPE=1

linecat_sized: linecat.c
		$(CC) $(PCFLAGS) -o $@ $< $(LDFLAGS) -DCAT_TYPE=2


strip: $(ALL)
		@for i in $(ALL); do \
		echo "Creating: $$i-s"; cp $$i $$i-s; strip $$i-s; \
		done

clean:
		rm -f *.o $(ALL) $(LIB_STATIC) *-s

## ustr 1.0.4

=== Documentation/Makefile ===
ALL = \
  functions.html \
  constants.html \
  ustr.3 \
  ustr_const.3 \

all: $(ALL)

#  This _shouldn't_ be part of teh normal build ... so we need to make sure it
# happens before we distribute.

functions.html: functions.txt txt2html.pl
		./txt2html.pl

constants.html: constants.txt txt2html.pl
		./txt2html.pl

ustr.3: functions.txt txt2man.pl
		./txt2man.pl

ustr_const.3: constants.txt txt2man.pl
		./txt2man.pl

=== debian/changelog ===
ustr (1.0.4-6) unstable; urgency=low

  * Patch fixes/autoconf:
    - Fixed race condition on creation shared library symbolic links when make
      runs parallel. Thanks to Yann E. MORIN <yann.morin.1998@free.fr>.
    - Fixed FTBFS (LDFLAGS with -pie): move LDFLAGS before -shared. Thanks to
      Helmut Grohne <helmut@subdivi.de>.
      Closes: #843459
  * Patch fixes/man-spelling: added corrections.
  * Added fixes/attr-nonnull: to disable nonnull attribute.
  * Added fixes/suppress-warn: to suppress warning about indentation.
  * Added hardening=+all in the debian/rules.
  * Changed Vcs-Git to URL with https.
  * Changed Standards-Version to 3.9.8.
  * Added build-dependency on quilt and include /usr/share/quilt/quilt.make
    in the debian/rules as suggested in /usr/share/topgit/tg2quilt.mk.
  * Added dummy rule for /usr/share/topgit/tg2quilt.mk, because package not
    build-depend on topgit and make tries to build this missing file using
    implicit rule with dh producing spurious errors in log.
  * For libustr-doc added Multi-Arch: foreign.

 -- Vaclav Ovsik <vaclav.ovsik@i.cz>  Wed, 23 Nov 2016 20:59:34 +0100

ustr (1.0.4-5) unstable; urgency=low

  * Fixed transition from the doc directory to a symlink
    /usr/share/doc/<PACKAGE> for libustr-1.0-1-dbg and libustr-dev
    by added {libustr-1.0-1-dbg,libustr-dev}.maintscript.
    Closes: #788169

 -- Vaclav Ovsik <vaclav.ovsik@i.cz>  Tue, 09 Jun 2015 11:11:42 +0200

ustr (1.0.4-4) unstable; urgency=low

  * Added patch fixes/autoconf, to use GNU Autoconf instead of its own
    auto-configuration driven by makefile rules. This is more general and
    flexible and it supports cross-compilation.
    Closes: #697698, #721352
  * Removed patch debian/reentrant, -D_REENTRANT no longer required by policy
  * Removed patch debian/locations, Debian locations are auto-configured now
  * Added patch fixes/gnu-inline providing compatible with C99 inline
    Closes: #777460
  * Added patch fixes/stdarg-va_copy to suppress gcc-4.9 warning
  * Added patch fixes/doc-html-local-css to replace link to remote CSS with
    the local copy in the HTML documentation.
  * Dropped ustr-import and corresponding sources, noticed in README.Debian
  * Added alternate debian/control.wdbg to generate binary packages
    suitable for debugging also (libustr-debug-1.0-1, libustr-debug-1.0-1-dbg
    and libustr-debug-dev), noticed in README.Debian.
  * Removed some unimportant files from /usr/share/doc/..., used links to
    reduce duplicity between packages.
  * Support Multi-Arch for development package (libustr-dev).
  * Switch to dh from cdbs
  * Switch to dpkg-source 3.0 (quilt) format
  * Changed Standards-Version to 3.9.6

 -- Vaclav Ovsik <vaclav.ovsik@i.cz>  Thu, 12 Mar 2015 23:06:42 +0100

ustr (1.0.4-3) unstable; urgency=low

  * Changed debian/watch, upstream ftp is no longer available
  * Changed Standards-Version to 3.9.3
  * Support Multi-Arch for shared library. Closes: #676155
  * Changed debian/copyright to machine-readable format
  * Hardening: append CPPFLAGS to CFLAGS
  * Added patch fixes/man-spelling, to fix spelling errors in man-pages
    reported newly by the lintian
  * Added debian/source/format with 1.0 version number

 -- Vaclav Ovsik <vaclav.ovsik@i.cz>  Wed, 30 May 2012 09:48:12 +0200

ustr (1.0.4-2) unstable; urgency=low

  * Extended package descriptions in debian/control
  * Fixed section fields in debian/control
  * Changed Standards-Version to 3.8.3
  * Added debian/libustr-1.0-1.symbols
  * Used TopGit and Quilt to manage patches, added README.source
  * Added patch fixes/nonlinux, removes conditional compilation directives
    `#ifdef __linux__', so the build process can succeed on non linux
    (Debian GNU/kFreeBSD). Closes: #536890

 -- Vaclav Ovsik <vaclav.ovsik@i.cz>  Sat, 29 Aug 2009 23:40:00 +0200

ustr (1.0.4-1) unstable; urgency=low

  * New Upstream Version
  * Dropped patches that were incorporated upstream:
    - struct-size-assert-arm.patch
    - tst-64bit-mmap-fix.patch
    - ustr-import-bashism-fix.patch
  * man-cleanup.patch, debian.patch: updated for latest release.

 -- Vaclav Ovsik <vaclav.ovsik@i.cz>  Fri, 07 Mar 2008 08:32:35 +0100

ustr (1.0.3-3) unstable; urgency=low

  * the source package rearranged, changes to upstream are represented
    as separated patches in debian/patches only (quilt used)
  * the patch tst-64bit-mmap-fix fixes bug in the test of mmap()
    return value in a 64bit test, which prevents successful package build
    for architecture S390. Closes: #466839
  * the patch struct-size-assert-arm commets out a line with assertion for
    sizeof struct Ustr, which is padded to 32-bit boundary on ARM
    architecture and assertion fails.

 -- Vaclav Ovsik <vaclav.ovsik@i.cz>  Mon, 03 Mar 2008 15:22:14 +0100

ustr (1.0.3-2) unstable; urgency=low

  * ustr-import: removed bashism - function definitions using
    the keyword `function'. Closes: #465005
  * ustr.3, ustr_const.3, ustr_import.1: removed undefined macros
    (.NH, .HY, .Vb, .Ve). The lintian warned about it.

 -- Vaclav Ovsik <vaclav.ovsik@i.cz>  Mon, 11 Feb 2008 13:13:13 +0100

ustr (1.0.3-1) unstable; urgency=low

  * Initial release.
  * Closes: #447269:  ITP: ustr -- Micro string library

 -- Vaclav Ovsik <vaclav.ovsik@i.cz>  Wed, 16 Jan 2008 08:50:12 +0100

=== debian/control ===
Source: ustr
Section: libs
Priority: optional
Maintainer: Vaclav Ovsik <vaclav.ovsik@i.cz>
Build-Depends: autoconf (>=2.69), debhelper (>= 9), dh-autoreconf, quilt
Standards-Version: 3.9.8
Homepage: http://www.and.org/ustr/
Vcs-Git: https://anonscm.debian.org/git/users/zito-guest/pkg-ustr.git
Vcs-Browser: https://anonscm.debian.org/cgit/users/zito-guest/pkg-ustr.git

Package: libustr-1.0-1
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Micro string library: shared library
 ustr (Micro string library) is a string API for C. It has tiny overhead over
 just plain strdup(), is much safer, is easier to use, is faster for many
 operations, can be used with read-only or automatically allocated data. You
 don't even need to link to the library to use it (so there are no
 dependencies).
 .
 This package contains the shared library.

Package: libustr-1.0-1-dbg
Architecture: any
Multi-Arch: same
Section: debug
Priority: extra
Pre-Depends: ${misc:Pre-Depends}
Depends: libustr-1.0-1 (= ${binary:Version}), ${misc:Depends}
Description: Micro string library: debugging symbols
 ustr (Micro string library) is a string API for C. It has tiny overhead over
 just plain strdup(), is much safer, is easier to use, is faster for many
 operations, can be used with read-only or automatically allocated data. You
 don't even need to link to the library to use it (so there are no
 dependencies).
 .
 This package contains debugging symbols for shared library.

Package: libustr-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Pre-Depends: ${misc:Pre-Depends}
Depends: libustr-1.0-1 (= ${binary:Version}), libc6-dev, ${misc:Depends}
Description: Micro string library: development stuff
 ustr (Micro string library) is a string API for C. It has tiny overhead over
 just plain strdup(), is much safer, is easier to use, is faster for many
 operations, can be used with read-only or automatically allocated data. You
 don't even need to link to the library to use it (so there are no
 dependencies).
 .
 This package contains header files and static library needed to compile code
 that uses ustr.

Package: libustr-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Suggests: libustr-dev
Depends: ${misc:Depends}
Description: Micro string library: documentation
 ustr (Micro string library) is a string API for C. It has tiny overhead over
 just plain strdup(), is much safer, is easier to use, is faster for many
 operations, can be used with read-only or automatically allocated data. You
 don't even need to link to the library to use it (so there are no
 dependencies).
 .
 This package provides HTML documentation and examples.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/quilt/quilt.make
-include /usr/share/topgit/tg2quilt.mk

/usr/share/topgit/tg2quilt.mk:
	@true

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

build_debug=${shell grep '^Package:.*debug' debian/control && echo 1}

ifeq (${build_debug},)
    build_target=all-opt
    install_target=install-opt
else
    build_target=all all-shared
    install_target=install
endif


%:
	dh $@ --with autoreconf

override_dh_auto_build:
	${MAKE} ${build_target}

override_dh_auto_install:
	${MAKE} ${install_target} DESTDIR=debian/tmp \
		libdir=\$${prefix}/lib/${DEB_HOST_MULTIARCH} \
		bin_arch_prefix=${DEB_HOST_MULTIARCH}- \
		includedir_arch=\$${includedir}/${DEB_HOST_MULTIARCH}

override_dh_installdocs:
	dh_installdocs -plibustr-1.0-1-dbg --link-doc=libustr-1.0-1
	dh_installdocs -plibustr-dev --link-doc=libustr-1.0-1
ifneq (${build_debug},)
	dh_installdocs -plibustr-debug-1.0-1-dbg --link-doc=libustr-debug-1.0-1
	dh_installdocs -plibustr-debug-dev --link-doc=libustr-debug-1.0-1
endif
	dh_installdocs

override_dh_strip:
	dh_strip -plibustr-1.0-1 --dbg-package=libustr-1.0-1-dbg
ifneq (${build_debug},)
	dh_strip -plibustr-debug-1.0-1 --dbg-package=libustr-debug-1.0-1-dbg
endif
	dh_strip --exclude=libustr-debug.a

override_dh_clean:
	test -f Makefile && fgrep -q maintainer-clean Makefile && ${MAKE} maintainer-clean || true
	dh_clean

=== debian/watch ===
version=3
# uscan can't handle redirection, so a workround using downloadurlmangle...
# http://ftp.and.org/ustr/latest/
#   => http://ftp.and.org/ustr/1.0.4/ustr-1.0.4.tar.gz
opts=downloadurlmangle=s|/latest/ustr-(\d+(?:\.\d+)*)|/$1/ustr-$1| \
    http://www.and.org/ustr/latest/ ustr-(\d+(?:\.\d+)*)\.tar\.gz
